#!/bin/sh
#
# initreg       This shell script takes care of starting and stopping
#               the Regulus services
#
# Source function library.
. /etc/rc.d/init.d/functions

# Source networking configuration.
if [ ! -f /etc/sysconfig/network ]; then
    exit 0
fi

if [ ! -n ${REGBASE} ]; then
  . /etc/sysconfig/regulus
else
  . ${REGBASE}/conf/regulus.conf
fi

# Check that regulus is here
[ -x $base/bin/rulers ] || exit 0

# See how we were called.
case "$1" in
  start)
	# Start daemons.
	action "Starting Regulus services: " true
	echo -n "Starting data-base daemon "
	daemon /usr/bin/postmaster -S -D${REGBASE} -p${REGPORT}
	touch /var/lock/subsys/regulus
	;;
  stop)
	# Stop daemons.
	action "Shutting down Regulus services: " true
	killproc postmaster
	rm -f /var/lock/subsys/regulus
	;;
  status)
	status regulus
	;;
  restart)
	echo -n "Restarting Regulus services: "
	echo -n "postmaster"
	killall -HUP postmaster 
	touch /var/lock/subsys/regulus
	echo "done."
	;;
  *)
	echo "Usage: nfs {start|stop|status|restart}"
	exit 1
esac

exit 0

