#! /bin/sh
#---------------------------------------------------------------------
#this is a shell script to update /etc/passwd with data-comming
#from Regulus when the user's password is updated.
#
#BEWARE!
#	Do not modify that file, duplicate it first in
#	/var/lib/regulus2/conf/shell and then modify
#	the NEWLY COPIED file to fit your exact needs.
#
#  parameters:
#  userid      user
#  shell       shell in /etc/passwd
#  home        home directory for /etc/passwd
#  username    name for user
#  action      NEW(new) DEL(delete) MAJ (just modify a passwd)
#              SUSPEND (suspend acces for user) ACTIVE(reactive user supended)
#  uid         user id
#  gid         group id
#  port	       data-base access port
#  newpass1    password
#  passf       if passf==e then password is in encrypted form.
#
#---------------------------------------------------------------------
#avoiding any race condition
LOCK=/tmp/regadduser.sh.lock
if [ -x /usr/bin/shlock ] ; then
  until /usr/bin/shlock -p $$ -f $LOCK
    do
    sleep 1
    done
fi

cd `dirname $0`
. $base/conf/regulus.conf
#---------------------------------------------------------------------
DBGFILE=/dev/null
#---------------------------------------------------------------------
#setting up the SQL parameter
owner=`ls -do $base/dbm | tr -s ' ' |  cut -f 3 -d" "`
/bin/echo "owner =$owner" >> $DBGFILE
case "$SQLBASE" in
  "postgresql" )
    SQL="/usr/bin/psql -q -t -p $port -U $dbusr -c"
    ;;
  "mysql" )
    SQL="/usr/bin/mysql --socket=$base/dbm/mysql.sock -u $dbusr -B -s -P $port -e"
    ;;
  *)
    echo "FATAL ERROR, 'SQLBASE' not defined"
    exit
    ;;
esac
/bin/echo "SQL=<"$SQL">" >> $DBGFILE
#---------------------------------------------------------------------
#to manage a remote site via a SSH connexion, comment in and update $SYS
#SYS="ssh remote_site"
if [ -Z $SYS ]; then
 NEWUS=$username
else
 NEWUS=\"$username\"
fi
if [ $action = NEW ]; then
okuser=`$SYS cat /etc/passwd | cut -f 1 -d":" | grep -c -w "$userid" `;
if [ $okuser = 1 ]; then
  #user allready existingt
  USERMODE=/usr/sbin/usermod
  echo $USERMODE -s $shell -d $home -c "$NEWUS" "$userid" >> $DBGFILE
  $SYS /usr/sbin/usermod -s $shell -d $home -c "$NEWUS" "$userid"
    dbuid=`$SQL "select uid from userreg where userid='$userid'" regulus`
    echo dbuid="$dbuid" >> $DBGFILE
    if [ -Z $dbuid ] || [ $dbuid = 0 ]; then
    uid=`cat /etc/passwd | cut -f 1-3 -d":" | grep -w "$userid" | cut -f 3 -d ":"`;
    gid=`cat /etc/passwd | cut -f 1-4 -d":" | grep -w "$userid" | cut -f 4 -d ":"`;
    echo $SQL "update userreg set uid='$uid',gid=$gid where userid='$userid'" regulus >> $DBGFILE
if [ `id -u` = 0 ]; then
    /bin/su -m - $dbusr -c "$SQL \"update userreg set uid=$uid,gid=$gid where userid='$userid'\" regulus"
else
    $SQL "update userreg set uid=$uid,gid=$gid where userid='$userid'" regulus
fi
    fi
else
  #user not yet existing
  ADDUSER=/usr/sbin/adduser
  if [ -Z $uid ]; then
    #uid is not in the parameters
    echo $ADDUSER -g $gid -s $shell -d $home -c "$NEWUS" "$userid" >> $DBGFILE
    $SYS $ADDUSER -g $gid -s $shell -d $home -c "$NEWUS" "$userid"
    #extract uid and update the data-base
    uid=`$SYS cat /etc/passwd | cut -f 1-3 -d":" | grep -w "$userid" | cut -f 3 -d ":"`;
    echo $SQL "update userreg set uid='$uid' where userid='$userid'" regulus >> $DBGFILE
if [ `id -u` = 0 ]; then
    /bin/su -m - $dbusr -c "$SQL \"update userreg set uid=$uid,gid=$gid where userid='$userid'\" regulus"
else
    $SQL "update userreg set uid=$uid,gid=$gid where userid='$userid'" regulus
fi

  else
    #uid allready provided
    echo $ADDUSER -g $gid -u $uid -s $shell -d $home -c "$username" "$userid" >> $DBGFILE
    $SYS $ADDUSER -g $gid -u $uid -s $shell -d $home -c "$NEWUS" "$userid"
    fi
  fi
else
if [ $action = DEL ]; then
  USERDEL=/usr/sbin/userdel
  echo $USERDEL -r "$userid" >> $DBGFILE
  $SYS /usr/sbin/userdel -r "$userid"
  fi
fi
#---------------------------------------------------------------------
#To update the password in the password file
#echo "$userid:$newpass1" >> $DBGFILE
if [ $action = MAJ  -o $action = NEW ]; then

if [ ! -n "$passf" ]; then # no preset passf set in the environement
    passf=nothing
fi
if [ $passf = e ]; then
/bin/echo "$userid:$newpass1" | $SYS /usr/sbin/chpasswd -e
else
/bin/echo "$userid:$newpass1" | $SYS /usr/sbin/chpasswd
  echo $userid:$newpass1 >> $DBGFILE
fi
if [ $lang = 'English' ]; then
echo "The PAP password provided is OK ";
else
echo "Le mot de passe PAP a ete change avec succes"
fi
fi
#---------------------------------------------------------------------
if [ $action = SUSPEND ]; then
if [ $lang = 'English' ]; then
echo "Suspended User ";
else
echo "Usager suspendu"
fi
fi
if [ $action = ACTIVE ]; then
if [ $lang = 'English' ]; then
echo "Reactived User ";
else
echo "Usager reactive"
fi
fi
#---------------------------------------------------------------------
#Area available for local customisation
#
#removing previous username entry in the Radius user file
#/bin/sed -e"/$username /d" < /etc/raddb/users > /etc/raddb/users.new
#adding user to the file, using UNIX password
#/bin/echo $username Password="UNIX" >> /etc/raddb/users.new
#setting the new file in place.
#mv -bf /etc/raddb/users.new /etc/raddb/users
#---------------------------------------------------------------------
