#! /bin/sh
#---------------------------------------------------------------------
#this is a shell script to update $base/conf/web with data-comming
#from Regulus when the web is provisionning
#
#BEWARE!
#       Do not modify that file, duplicate it first in
#       /var/lib/regulus2/conf/shell and then modify
#       the NEWLY COPIED file to fit your exact needs.
#
#  parameters:
#  userid      user
#  access      access type (ex: /bin/bash  /bin/ftponly)
#  siteweb     Website name
#  otype       P(professionnel web) W(personnel web)
#  port        data-base access port
#  base        base directory (/var/lib/regulus2)
#  action      PRO(provisionning)  DEL(delete)
#  home        home directory for install website (action=PRO)
#              home directory when the password is create (action=DEL)
#  oldhome     old home directory for install website (when action=DEL)
#  lang        Francais or English
#---------------------------------------------------------------------
#avoiding any race condition
LOCK=/tmp/regaddweb.sh.lock.$port
if [ -x /usr/bin/shlock ] ; then
  until /usr/bin/shlock -p $$ -f $LOCK
    do
    sleep 1
   done
fi
#---------------------------------------------------------------------
#
DBGFILE=/dev/null
cd `dirname $0`
web=$base/conf/web

echo $web  otype=$otype  action=$action >> $DBGFILE

#-  action=PRO for provisionning

if [ $action = PRO ]; then
okuser=`cat /etc/passwd | cut -f 1 -d":" | grep -c -w "$userid" `;

#okuser=1 si l'usager est deja cree
#il devrait deja etre cree avec mot de passe.
  if [ $okuser = 1 ]; then
    #user already existing
    USERMODE=/usr/sbin/usermod
    echo $USERMODE -s $access -d $home  $userid >> $DBGFILE
    /usr/sbin/usermod -s $access -d $home  "$userid"
  fi

  # creation du repertoire de l'usager
  if [ ! -d $home ]; then
    mkdir $home
    chown root.root $home
    chmod 755 $home
  fi
  if [ ! -d $home/public_html ]; then
    mkdir $home/public_html
    chown $userid.web $home/public_html
    newweb=`echo $siteweb | cut -f 1 -d "," `
    /bin/sed -e "s/DOMAIN/$newweb/" < \
 $base/conf/index.conf > $home/public_html/index.html
    chown $userid.web $home/public_html/index.html

#    mkdir $home/public_html/cgi-$userid
#    chown $userid.web $home/public_html/cgi-$userid
    fi
  #si web professionnel ajouter dans hreg.map,vreg.map et ireg.map
  if [ $otype = P ]; then



site=$siteweb

newweb=`echo $site | cut -f 1 -d "," `
site=`echo $site | cut -f 2- -d "," `
if [ "$newweb" = "$site" ]; then
site=""
fi
while [ "$newweb" != "" ]; do
    /bin/sed -e/"^$newweb\ "/d < $web/hreg.map > $web/hreg.map.new
    mv -f $web/hreg.map.new $web/hreg.map
    /bin/sed -e/"^$newweb\ "/d < $web/vreg.map > $web/vreg.map.new
    mv -f $web/vreg.map.new $web/vreg.map
    
    echo "$newweb public_html" >> $web/hreg.map
    echo "$newweb $home" >> $web/vreg.map

newweb=`echo $site | cut -f 1 -d "," `
site=`echo $site | cut -f 2- -d "," `
if [ "$newweb" = "$site" ]; then
site=""
fi
done;

    /bin/sed -e \\:$home:d < $web/ireg.map > $web/ireg.map.new
    mv -f $web/ireg.map.new $web/ireg.map
    echo "$home $userid" >> $web/ireg.map



    fi

  else
    #deprovisioning
    okuser=`cat /etc/passwd | cut -f 1 -d":" | grep -c -w "$userid" `;

  if [ $okuser = 1 ]; then
    #user already existing
    USERMODE=/usr/sbin/usermod
    echo $USERMODE -s $access -d $home  "$userid" >> $DBGFILE
    /usr/sbin/usermod -s $access -d $home  "$userid"
    fi

  #if professionnel web
  if [ $otype = P ]; then


site=$siteweb

newweb=`echo $site | cut -f 1 -d "," `
site=`echo $site | cut -f 2- -d "," `
if [ "$newweb" = "$site" ]; then
site=""
fi
while [ "$newweb" != "" ]; do


    
    /bin/sed -e/"$newweb"/d < $web/hreg.map > $web/hreg.map.new
    mv -f $web/hreg.map.new $web/hreg.map
    /bin/sed -e/"$newweb"/d < $web/vreg.map > $web/vreg.map.new
    mv -f $web/vreg.map.new $web/vreg.map
    

newweb=`echo $site | cut -f 1 -d "," `
site=`echo $site | cut -f 2- -d "," `
if [ "$newweb" = "$site" ]; then
site=""
fi
done;
  
    /bin/sed -e \\:$oldhome:d < $web/ireg.map > $web/ireg.map.new
    mv -f $web/ireg.map.new $web/ireg.map
    fi
  
fi


