#! /bin/sh
#-----------------------------------------------------
#script to charge (from scratch) a data-base contents
# $1 BASE 		(usualy /var/lib/regulus2)
# $2 DATAPATH		(path to the data to insert in the data-base)
#Beware:
#	This utility must be run while being user regulus
#-----------------------------------------------------
homebase=`basename $1`

#data-base cleaning specific function.
function startdaemon # base
{
$1/bin/rgmaster -b $1
}

function preppostgresql # base
{
startdaemon $1;
/bin/sleep 10
if [ -x /usr/bin/dropdb ]; then 
  /usr/bin/dropdb -p $SQLPORT regulus 
else
  /usr/bin/destroydb -p $SQLPORT regulus 
fi
/usr/bin/createdb -p $SQLPORT regulus 
}

function prepmysql # base
{
rm -fr $1/dbm/regulus
mkdir $1/dbm/regulus
startdaemon $1;
}


#-----------------------------------------------------
#loading the local configuration
. $1/conf/regulus.conf
case $SQLBASE in 
  "postgresql" )
     preppostgresql $1;
     ( \
     zcat $2 ; \
     /bin/echo "UPDATE web SET home='$1';" ; \
     /bin/echo "UPDATE web SET siteweb='acct2.$homebase.safe.ca' WHERE siteweb  LIKE 'acct2%'" \
     ) | psql -p $SQLPORT regulus
     sleep 5
     ;;
  "mysql" )
     prepmysql $1;
      ( /bin/echo "USE regulus" ; \
	zcat $2;\
        /bin/echo "UPDATE web SET home='$1';"; \
        /bin/echo "UPDATE web SET siteweb='acct2.$homebase.safe.ca' WHERE siteweb LIKE 'acct2%'" \
	 ) | mysql --socket=$1/dbm/mysql.sock
     ;;
  esac
sleep 5
kill -TERM `cat /var/lock/regulus2/LCK.rgmaster2-$SQLPORT`
/bin/echo "database "$2" now charged"
#-----------------------------------------------------
