#! /bin/sh
#--------------------------------------------------------
#shell to reload the data-base (with data from a 
#previous pg_dump)
#parameters
#$1 name of the file to upload
#$2 base directory name
#$3 SQL port number
#--------------------------------------------------------
waiting=2
BASE=/var/lib/regulus2
PORT=1610
/bin/echo "starting Data-base Upload in $waiting seconds"
sleep $waiting
if [ "$3" != "" ]; then
  PORT=$3
fi
if [ "$2" != "" ]; then
  BASE=$2
fi
if [ "$1" != "" ]; then
  /bin/echo "Starting Data-base daemon"
  $BASE/bin/rgmaster -b $BASE
  /bin/echo "removing data-base"
  /usr/bin/destroydb -p $PORT regulus
  /bin/echo "creating data-base"
  /usr/bin/createdb -p $PORT regulus 
  /bin/echo "Loading Regulus SQL table"
  $BASE/bin/mktable -c . -b $BASE inter.tbl
  psql -p $PORT -c"DROP SEQUENCE numcontract" regulus
  /bin/echo "Loading SQL data, (please wait)"
  cat $1 | /usr/bin/psql -q -p $PORT regulus
  psql -p $PORT -c"GRANT ALL ON numcontract TO nobody" regulus
  psql -p $PORT -c"update prices set prtype='P'" regulus
  psql -p $PORT -c"INSERT INTO otherprod select userid,otherp1,qop1,0 from userbill where otherp1>''" regulus
  psql -p $PORT -c"INSERT INTO otherprod select userid,otherp2,qop2,0 from userbill where otherp2>''" regulus
  psql -p $PORT -c"INSERT INTO otherprod select userid,otherp3,qop3,0 from userbill where otherp3>''" regulus
  /bin/echo "Data-base daemon shutdown"
  kill -TERM `cat /tmp/LCK.rgmaster2-$PORT`
else
  /bin/echo "No data base to upload"
fi
