#! /bin/sh
#----------------------------------------------------------
#This shell script must be run as Regulus
#----------------------------------------------------------
#defining the convertion function
#----------------------------------------------------------
function convert
{
echo
(
cd $1
echo `pwd`
echo "#base "$1
for j in `find [a-z,A-Z,0-9] -type f -print`
  do
  cat $j
  echo
  done
)
}
#----------------------------------------------------------
#starting dbase access daemon
#----------------------------------------------------------
/bin/echo "Starting rgmaster"
$BASE/bin/rgmaster -F -b$BASE
sleep 2

#----------------------------------------------------------
#setting the convertion directory
#----------------------------------------------------------
echo "Converting date from "$OLD
#----------------------------------------------------------
#cleaning and preparaing data-base
#----------------------------------------------------------
. $BASE/conf/regulus.conf
if [ -x /usr/bin/dropdb ]; then 
  /usr/bin/dropdb -p $SQLPORT regulus 
else
  /usr/bin/destroydb -p $SQLPORT regulus 
fi
createdb -p $SQLPORT regulus
/lib/cpp -P -DPOSTGRES $BASE/conf/regulus.tbl | $BASE/bin/mktable -b$BASE 
#----------------------------------------------------------
#converting the conf file
#----------------------------------------------------------
/bin/echo "Starting configuration transfer"
$BASE/bin/updconf -b $BASE $OLD/conf

#----------------------------------------------------------
#starting the data-base convertion
#----------------------------------------------------------
/bin/echo "Starting data (users info) transfer"
(
cd $OLD/dbm
for i in regdb regdb.inv regdb.dep
  do
  convert $i
  done
) | $BASE/bin/dbdcnv -v -b$BASE 


#----------------------------------------------------------
#stopping dbase access daemon
#----------------------------------------------------------
sleep 3
/bin/echo "Data-base convertion completed."
/bin/echo "Starting log transfer (could take long) while Regulus "
/bin/echo "is up and running (you can work on the new data-base)"
(
cd $OLD/dbm
for i in regdb.log
  do
  convert $i
  done
) | $BASE/bin/dbdcnv -v -b$BASE 
/bin/echo "Data-base convertion completed"
/bin/echo "Data-base convertion completed"
#--------------------------------------------------------------
/bin/echo "Check status in contract file"
psql -p $SQLPORT -c"update contract set status='C' where numcnt=ANY (select curinvseq from userbill where curinvseq<>'')" regulus
psql -p $SQLPORT -c"update contract set status='R' where numcnt=ANY (select repinvseq from userbill where repinvseq<>'')" regulus
psql -p $SQLPORT -c"update contract set status='N' where numcnt=ANY (select nexinvseq from userbill where nexinvseq<>'')" regulus
psql -p $SQLPORT -c"update contract set status='P' where numcnt in (select numcnt from contract where not exists (select * from userbill where contract.numcnt=curinvseq or contract.numcnt=repinvseq or contract.numcnt=nexinvseq))" regulus
psql -p $SQLPORT -c"update contract set act='Date' where act='date'" regulus
psql -p $SQLPORT -c"update userbill set repact='Date' where repact='date'" regulus
/bin/echo "Check status in contract file completed"
#--------------------------------------------------------------
sleep 5
kill -TERM `cat /var/lock/regulus2/LCK.rgmaster2-$SQLPORT`
/bin/echo "Stopping rgmaster"
sleep 3
